---
title: Программа для удаленного управления в локальной сети
slug: администрирование/программа-для-удаленного-управления-в-локальной-сети
---
# TightVNC — краткий справочник

**TightVNC** — это бесплатное приложение для удалённого управления рабочим столом через сеть.

---

## Основные функции

- Удалённое управление Windows и Linux через VNC-протокол.
- Поддержка передачи файлов.
- Возможность настройки пароля на подключение.
- Поддержка масштабирования экрана и сжатия данных для ускорения работы по медленным каналам.

---

## Установка

1. Скачать установщик с официального сайта: [https://www.tightvnc.com/](https://www.tightvnc.com/)
2. Установить компоненты:
   - **TightVNC Server** (если нужно принимать подключения).
   - **TightVNC Viewer** (если нужно подключаться к другим машинам).

---

## Быстрая настройка сервера

1. После установки запустить **TightVNC Server**.
2. Настроить пароль на подключение и управление сервером.
3. Убедиться, что порты **5900** (VNC) и **5800** (HTTP) открыты в фаерволе.

---

## Подключение к удалённой машине

1. Запустить **TightVNC Viewer**.
2. Ввести IP-адрес или имя компьютера, к которому хотите подключиться.
3. Ввести пароль для подключения.

---

## Порты

- **5900/TCP** — основной порт VNC-подключений.
- **5800/TCP** — для подключения через браузер (Java-апплет).

---

## Примеры запуска через командную строку

### Подключение Viewer с указанием IP и пароля

```bash
"C:\Program Files\TightVNC\tvnviewer.exe" -host=192.168.1.100 -password=yourpassword
```

### Запуск сервера без окна настроек

```bash
"C:\Program Files\TightVNC\tvnserver.exe" -run
```

_Параметр `-run` позволяет запустить сервер сразу в фоне._

### Основные параметры командной строки

| Компонент          | Ключ               | Описание                                 |
|--------------------|---------------------|------------------------------------------|
| TightVNC Viewer    | `-host=<адрес>`      | IP-адрес или имя удалённой машины        |
| TightVNC Viewer    | `-port=<порт>`       | Порт для подключения (по умолчанию 5900) |
| TightVNC Viewer    | `-password=<пароль>` | Пароль для подключения                  |
| TightVNC Server    | `-run`               | Запустить сервер в фоне                 |
| TightVNC Server    | `-controlservice`    | Управлять сервером через службу         |
| TightVNC Server    | `-stop`              | Остановить запущенный сервер            |

---

## Примеры скриптов автозапуска и подключения

### Автозапуск TightVNC Server при старте Windows

Добавить ярлык в папку автозагрузки с командой:

```bash
"C:\Program Files\TightVNC\tvnserver.exe" -run
```

Или создать bat-файл:

```bat
@echo off
start "" "C:\Program Files\TightVNC\tvnserver.exe" -run
```

### Быстрое подключение Viewer к удалённому ПК

Создать bat-файл:

```bat
@echo off
start "" "C:\Program Files\TightVNC\tvnviewer.exe" -host=192.168.1.100 -password=yourpassword
```

Такой скрипт можно положить на рабочий стол для быстрого подключения.

---

_Важно:_ Для безопасности рекомендуется использовать VNC через VPN или SSH-туннель, так как шифрование по умолчанию отсутствует.

---
