---
title: Пример создания http-запроса к API-сайта
slug: общие-обмен-данными-http-сервис/пример-создания-http-запроса-к-api-сайта
---

Пример запроса к ресурсу `https://proverkacheka.com/api/v1/check/get`
```bsl
АдресХоста = "proverkacheka.com";
АдресРесурса = "/api/v1/check/get";
	
ЗащищенноеСоединение = Новый ЗащищенноеСоединениеOpenSSL;
Соединение = Новый HTTPСоединение(АдресХоста, 443, , , , 30, ЗащищенноеСоединение);
	
Запрос = Новый HTTPЗапрос(АдресРесурса);
Запрос.Заголовки.Вставить("Content-Type", "application/x-www-form-urlencoded"); 
// application/x-www-form-urlencoded - формат, когда тело передается строкой с парами "Ключ-значение", разделенными &

// формат запроса читаем в документации к api
// Т.к. амерсанд разделяет пары, то нужно, чтобы в значениях его не было. Заменяем на %26
Тело = СтрШаблон("token=%1&qrraw=%2", "my_secret_token", СтрЗаменить(СыройТекстQRКода(), "&", "%26")); 
	
Запрос.УстановитьТелоИзСтроки(Тело, КодировкаТекста.UTF8);
Ответ = Соединение.ОтправитьДляОбработки(Запрос); // это POST, см. синтакс-помощник
	
ТелоОтвета = Ответ.ПолучитьТелоКакСтроку(КодировкаТекста.UTF8);
	
Если Ответ.КодСостояния = 200 Тогда // запрос обработан успешно
    // обрабатываем результат
Иначе
    // Обрабатываем ошибку
КонецЕсли;
```