---
title: Добавление команд отчетов
slug: общие-подключение-объектов-к-бсп/добавление-команд-отчетов
---

# В общем модуле `ВариантыОтчетовПереопределяемый` добавляем свой объект

```bsl

// Определяет объекты конфигурации, в модулях менеджеров которых предусмотрена процедура ДобавитьКомандыОтчетов,
// описывающая команды открытия контекстных отчетов.
// Синтаксис процедуры ДобавитьКомандыОтчетов см. в документации.
//
// Параметры:
//  Объекты - Массив - объекты метаданных (ОбъектМетаданных) с командами отчетов.
//
Процедура ОпределитьОбъектыСКомандамиОтчетов(Объекты) Экспорт
	// _Демо начало примера
	Объекты.Добавить(Метаданные.Справочники._ДемоОрганизации);
	Объекты.Добавить(Метаданные.Справочники._ДемоКонтрагенты);
	Объекты.Добавить(Метаданные.Справочники._ДемоМестаХранения);
	Объекты.Добавить(Метаданные.Документы._ДемоПоступлениеТоваров);
	Объекты.Добавить(Метаданные.Документы._ДемоРеализацияТоваров);
	// _Демо конец примера
КонецПроцедуры

```

# В модуле менеджера
```bsl
// Заполняет список команд отчетов.
// 
// Параметры:
// 	КомандыОтчетов - см. ВариантыОтчетовПереопределяемый.ПередДобавлениемКомандОтчетов.КомандыОтчетов
// 	Параметры - см. ВариантыОтчетовПереопределяемый.ПередДобавлениемКомандОтчетов.Параметры
//
Процедура ДобавитьКомандыОтчетов(КомандыОтчетов, Параметры) Экспорт
	
	// Если есть функция программного интерфейса у отчета	
	КомандаОтчет = Отчеты.КонтрольПоставкиСырьяИМатериаловДавальцем.ДобавитьКомандуОтчета(КомандыОтчетов);
	Если КомандаОтчет <> Неопределено Тогда
		КомандаОтчет.Важность = "СмТакже";
		КомандаОтчет.Порядок = 1;
	КонецЕсли;

    // создание команды отчета "вручную"
	Если ПравоДоступа("Просмотр", Метаданные.Отчеты.РасшифровкаСтоимостиПереработки) Тогда
		
		КомандаОтчет = КомандыОтчетов.Добавить();
		
		КомандаОтчет.Менеджер = Метаданные.Отчеты.РасшифровкаСтоимостиПереработки.ПолноеИмя();
		КомандаОтчет.Представление = НСтр("ru = 'Расшифровка стоимости переработки';
											|en = 'Overtime cost drill-down'");
		КомандаОтчет.МножественныйВыбор = Истина;
		КомандаОтчет.Важность = "Обычное";
		
		КомандаОтчет.КлючВарианта = "РасшифровкаСтоимости";
		
	КонецЕсли;

КонецПроцедуры
```

# Подключение к подсистеме "Подключаемые команды"
См. `Подключение к подсистемам - Подключение к подсистеме "Подключаемые команды"`