---
title: Отладка сложных запросов
slug: общие-работа-с-запросами/отладка-сложных-запросов
---

> Большое спасибо [Ивану Гордынцу](https://www.youtube.com/watch?v=5PNcQwwL5cc)

# Шаг 1
Создать расширение, импортировать [консоль запросов](/otladka-slozhnyh-zaprosov/upravlyaemaya-konsol-otchetov.epf)

# Шаг 2
В модуле обработки есть 2 метода, которые позволяют сохранить данные запроса в файл для последующего открытия в консоли запросов
```bsl
Функция СохранитьВФайл(Объект, Путь, ИмяБезРасширения = Неопределено) Экспорт
...
Функция СохранитьВНастройки(Объект, ИмяНастройки = Неопределено) Экспорт
```
# Шаг 3
Установить точку останова перед непосредственным выполнением запроса, т.е. после формирования текста запроса, установки параметров, инициализации временных таблиц и пр.
![Скриншот 1](/otladka-slozhnyh-zaprosov/screenshot1.png)
После остановки в точке останова нажимаем `Shift + F9` и вставляем следующее выражение
```bsl
Обработки.УКО_УправляемаяКонсольОтчетов.Создать().СохранитьВНастройки(Запрос, "ИмяЗапросаВНастройках")
```
где `Запрос` - переменная типа `Запрос`, `ИмяЗапросаВНастройках` - имя, под которым запрос сохраняется в настройки.

# Шаг 4
Вычисляем выражение. Запрос сохранен успешно, когда в результате появляется строка со значением `Сохранено успешно`
![Скриншот 1](/otladka-slozhnyh-zaprosov/screenshot2.png)
 
 # Шаг 5
 После этого открываем обработку из шага 1, и в подменю `Данные` будет пункт с именем, указанным в шаге 3
 ![Скриншот 1](/otladka-slozhnyh-zaprosov/screenshot3.png)

 # Итог
 После этого в обработку загрузится текст запроса, установленные параметры, временные таблицы, что позволит быстро отладить запрос
