---
title: Создание групп формы
slug: общие-управляемые-формы-программное-создание-элементов-формы/создание-групп-формы
---

### Обычная группа без отображения
```bsl
ГруппаДатаНомер = Элементы.Добавить("ГруппаОбычная", Тип("ГруппаФормы"),ЭтаФорма);
ГруппаДатаНомер.Вид = ВидГруппыФормы.ОбычнаяГруппа;
ГруппаДатаНомер.Отображение = ОтображениеОбычнойГруппы.Нет;
ГруппаДатаНомер.ОтображатьЗаголовок = ЛОЖЬ; 
ГруппаДатаНомер.Группировка = ГруппировкаПодчиненныхЭлементовФормы.ГоризонтальнаяВсегда;
```

### Обычная группа
```bsl
//Пример создания обычной группы
ГруппаШапка = Элементы.Добавить("ГруппаШапка", Тип("ГруппаФормы"), ЭтотОбъект);
ГруппаШапка.Вид = ВидГруппыФормы.ОбычнаяГруппа;
ГруппаШапка.Заголовок = "Основные реквизиты";
ГруппаШапка.Отображение = ОтображениеОбычнойГруппы.ОбычноеВыделение;
ГруппаШапка.ОтображатьЗаголовок = ИСТИНА; 
ГруппаШапка.Группировка = ГруппировкаПодчиненныхЭлементовФормы.Вертикальная;
ГруппаШапка.РастягиватьПоГоризонтали = ИСТИНА;
```

### Свертываемая группа
```bsl
ГруппаХарактеристики = Элементы.Добавить("СвертываемаяГруппа", Тип("ГруппаФормы"), Элементы.СтраницаКонтейнер);
ГруппаХарактеристики.Заголовок = "СвертываемаяГруппа";
ГруппаХарактеристики.Вид = ВидГруппыФормы.ОбычнаяГруппа;
ГруппаХарактеристики.Поведение = ПоведениеОбычнойГруппы.Свертываемая;
ГруппаХарактеристики.ОтображатьОтступСлева = Истина;
ГруппаХарактеристики.ОтображениеУправления = ОтображениеУправленияОбычнойГруппы.Картинка;
	
```

### Группа страниц
```bsl	
//Пример создания группы страниц
ГруппаСтраниц = Элементы.Добавить("ГруппаСтраницы", Тип("ГруппаФормы"), ЭтотОбъект);
ГруппаСтраниц.Вид = ВидГруппыФормы.Страницы;
ГруппаСтраниц.ОтображениеСтраниц = ОтображениеСтраницФормы.ЗакладкиСверху;
ГруппаСтраниц.РастягиватьПоГоризонтали = ИСТИНА;

```

### Страницы
```bsl	
СтраницаТовары = Элементы.Добавить("СтраницаТовары", Тип("ГруппаФормы"), ГруппаСтраниц);
СтраницаТовары.Вид = ВидГруппыФормы.Страница;
СтраницаТовары.Заголовок = "Товары";
	
СтраницаДополнительно = Элементы.Добавить("СтраницаДополнительно", Тип("ГруппаФормы"), ГруппаСтраниц);
СтраницаДополнительно.Вид = ВидГруппыФормы.Страница;
СтраницаДополнительно.Заголовок = "Дополнительно";
```