---
title: Шаблоны регулярок
slug: прочее-регулярные-выражения/шаблоны-регулярок
---
# 📚 Часто используемые регулярные выражения

Полезная мини-библиотека шаблонов на каждый день.

---

## 📧 Email

```regex
\b[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,}\b
```

---

## 📱 Телефон (Россия)

```regex
\+7\s?\(?\d{3}\)?\s?\d{3}[-\s]?\d{2}[-\s]?\d{2}
```

---

## 🔗 URL

```regex
https?:\/\/(www\.)?[a-zA-Z0-9\-]+(\.[a-zA-Z]{2,})+(\/\S*)?
```

---

## 🔢 Только числа

```regex
^\d+$
```

---

## 🔠 Только буквы

```regex
^[a-zA-Zа-яА-Я]+$
```

---

## 🆔 UUID (GUID)

```regex
[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}
```

---

## 📅 Дата в формате YYYY-MM-DD

```regex
\d{4}-\d{2}-\d{2}
```

---

## 💳 Номер банковской карты (16 цифр)

```regex
\b\d{4}[- ]?\d{4}[- ]?\d{4}[- ]?\d{4}\b
```

---

## 💻 IP-адрес (IPv4)

```regex
\b(?:\d{1,3}\.){3}\d{1,3}\b
```

---

## 🔐 Пароль (минимум 8 символов, буквы и цифры)

```regex
^(?=.*[A-Za-z])(?=.*\d)[A-Za-z\d]{8,}$
```

---

## 📦 Почтовый индекс (Россия)

```regex
\b\d{6}\b
```

---

## 🧼 HTML-теги

```regex
<[^>]+>
```

---

## 🔍 Ненулевое число с десятичной точкой

```regex
^\d*\.\d+$
```

---

## 📁 Расширение файла `.jpg`, `.png`, `.gif`

```regex
\.(jpe?g|png|gif)$
```

